#include "header/vr_ovr.h"
#include <stdlib.h>
#include <string.h>

#ifndef Q2VR_NONE_HMD
#define Q2VR_NONE_HMD 1
#endif

ovrDetectResult ovr_Detect( int timeout )
{
	ovrDetectResult result        = {};
	result.IsOculusServiceRunning = Q2VR_NONE_HMD;
	result.IsOculusHMDConnected   = Q2VR_NONE_HMD;
	return result;
}

ovrEyeRenderDesc ovr_GetRenderDesc( ovrSession session, ovrEyeType eyeType, ovrFovPort fov )
{
	ovrEyeRenderDesc eyeRenderDesc = {};
	// TODO
	return eyeRenderDesc;
}

ovrHmdDesc ovr_GetHmdDesc( ovrSession session )
{
	ovrHmdDesc hmdDesc = {};
	hmdDesc.Type       = ovrHmd_None;
	strncpy( hmdDesc.ProductName, "Emulated HMD", 63 );
	strncpy( hmdDesc.Manufacturer, "Nephatrine", 63 );
	hmdDesc.VendorId  = 0;
	hmdDesc.ProductId = 0;
	strncpy( hmdDesc.SerialNumber, "NXEMUHMD", 23 );
	hmdDesc.FirmwareMajor         = 0;
	hmdDesc.FirmwareMinor         = 0;
	hmdDesc.AvailableHmdCaps      = 0;
	hmdDesc.DefaultHmdCaps        = 0;
	hmdDesc.AvailableTrackingCaps = 0;
	hmdDesc.DefaultTrackingCaps   = 0;
	// TODO
	//	hmdDesc.DefaultEyeFov[i] =
	//	hmdDesc.MaxEyeFov[i] =
	//	hmdDesc.Resolution =
	//	hmdDesc.DisplayRefreshRate =
	return hmdDesc;
}

ovrResult ovr_Create( ovrSession * pSession, ovrGraphicsLuid * pLuid )
{
	if( pSession == NULL ) return ovrError_InvalidParameter;
	*pSession = Q2VR_NONE_HMD;
	return Q2VR_NONE_HMD;
}

ovrResult ovr_GetInputState( ovrSession session, ovrControllerType controllerType, ovrInputState * inputState )
{
	ovrInputState state = {};

	if( inputState == NULL ) return ovrError_InvalidParameter;
	if( session == NULL ) return ovrError_InvalidSession;

	// TODO?

	*inputState = state;
	return ovrSuccess;
}

ovrResult ovr_GetSessionStatus( ovrSession session, ovrSessionStatus * sessionStatus )
{
	if( sessionStatus == NULL ) return ovrError_InvalidParameter;
	if( session == NULL ) return ovrError_InvalidSession;
	sessionStatus->IsVisible      = Q2VR_NONE_HMD;
	sessionStatus->HmdPresent     = Q2VR_NONE_HMD;
	sessionStatus->HmdMounted     = Q2VR_NONE_HMD;
	sessionStatus->DisplayLost    = ovrFalse;
	sessionStatus->ShouldQuit     = ovrFalse;
	sessionStatus->ShouldRecenter = ovrFalse;
	//	sessionStatus->HasInputFocus  = Q2VR_NONE_HMD;
	//	sessionStatus->OverlayPresent = ovrFalse;
	//	sessionStatus->DepthRequested = ovrFalse;
	return ovrSuccess;
}

ovrResult ovr_Initialize( const ovrInitParams * params ) { return Q2VR_NONE_HMD ? ovrSuccess : ovrError_NotInitialized; }

ovrResult ovr_RecenterTrackingOrigin( ovrSession session )
{
	if( session == NULL ) return ovrError_InvalidSession;
	return ovrSuccess;
}

ovrResult ovr_SetTrackingOriginType( ovrSession session, ovrTrackingOrigin origin )
{
	if( session == NULL ) return ovrError_InvalidSession;
	return ovrSuccess;
}

ovrTrackerDesc ovr_GetTrackerDesc( ovrSession session, unsigned int trackerDescIndex )
{
	ovrTrackerDesc trackerDesc = {};
	return trackerDesc;
}

ovrTrackingState ovr_GetTrackingState( ovrSession session, double absTime, ovrBool latencyMarker )
{
	ovrTrackingState trackingState = {};
	return trackingState;
}

double ovr_GetPredictedDisplayTime( ovrSession session, long long frameIndex ) { return ovr_GetTimeInSeconds(); }

unsigned int ovr_GetConnectedControllerTypes( ovrSession session ) { return ovrControllerType_None; }

void ovr_Destroy( ovrSession session ) {}

void ovr_GetLastErrorInfo( ovrErrorInfo * errorInfo )
{
	if( errorInfo == NULL ) return;
	errorInfo->ErrorString[511] = 0;
	strncpy( errorInfo->ErrorString, "No VR Backend", 511 );
	errorInfo->Result = ovrError_NotInitialized;
}

void ovr_Shutdown() {}
